Subject: Re: QEMU PIC indirection patch for in-kernel APIC work

From: Avi Kivity <avi-atKUWr5tajBWk0Htik3J/[email-masked]>
Date: Mon, 09 Apr 2007 10:10:20 +0300

Rusty Russell wrote:
> On Sun, 2007-04-08 at 08:36 +0300, Avi Kivity wrote:
>   
>> Rusty Russell wrote:
>>     
>>> Hi Avi,
>>>
>>> 	I don't think you've thought about this very hard.  The receive copy is
>>> completely independent with whether the packet is going to the guest via
>>> a kernel driver or via userspace, so not relevant.
>>>   
>>>       
>> A packet received in the kernel cannot be made available to userspace in 
>> a safe manner without a copy, as it will not be aligned with page 
>> boundaries, so userspace cannot examine the packet until after one copy 
>> has occured.
>>     
>
> Hi Avi!
>
> 	I'm a little puzzled by your response.  Hmm...
>
> 	lguest's userspace network frontend does exactly as many copies as
> Ingo's in-host-kernel code.  One from the Guest, one to the Guest.
>
>   

kvm pvnet is suboptimal now.  The number of copies could be reduced by 
two (to zero), by constructing an skb that points to guest memory.  
Right now, this can only be done in-kernel.

With current userspace networking interfaces, one cannot build a network 
device that has less than one copy on transmit, because sendmsg() *must* 
copy the data (as there is no completion notification).  sendfilev(), 
even if it existed, cannot be used: it is copyless, but lacks completion 
notification.  It is useful only on unchanging data like read-only files.

-- 
Do not meddle in the internals of kernels, for they are subtle and quick to panic.

-------------------------------------------------------------------------
Take Surveys. Earn Cash. Influence the Future of IT
Join SourceForge.net's Techsay panel and you'll get the chance to share your
opinions on IT & business topics through brief surveys-and earn cash
http://www.techsay.com/default.php?page=join.php&p=sourceforge&CID=DEVDEV